#include "StdAfx.h"
#include "object_character.h"
#include "object_player.h"
#include "../../misc.h"
#include "object_dynamic.h"
#include "../phys/phys_collisionsolver.h"
#include "../phys/sap/OPC_ArraySAP.h"

extern Opcode::ArraySAP *asap;

void ObjCharacter::ProcessShooting()
{
	if (this->IsSleep())
		return;

	if ( this->sprite->mpCount < 1 && this->activity == oatShooting )
	{
		sLog(DEFAULT_LOG_NAME, LOG_ERROR_EV, "     ");
		return;
	}

	switch (this->shootingBeh)
	{
	case csbFreeShooting:
		if (this->activity == oatShooting && (this->type != objPlayer || ((ObjPlayer*)this)->HasAmmo() ))
		{
			if (this->type == objPlayer) ((ObjPlayer*)this)->SpendAmmo();
			if (this->sprite->IsMirrored()) this->cur_weapon->Fire(this, this->aabb.p+Vector2( -(this->sprite->mp[0].x), this->sprite->mp[0].y ));
			else this->cur_weapon->Fire(this, this->aabb.p+this->sprite->mp[0]);
		}
		break;
	case csbOnAnimCommand:
		if (this->type != objPlayer || ((ObjPlayer*)this)->HasAmmo() )
		{
			((ObjPlayer*)this)->SpendAmmo();
			if (this->sprite->IsMirrored()) this->cur_weapon->Fire(this, this->aabb.p+Vector2( -(this->sprite->mp[0].x), this->sprite->mp[0].y ));
			else this->cur_weapon->Fire(this, this->aabb.p+this->sprite->mp[0]);
		}
		this->shootingBeh = csbNoShooting;
		break;
	default: break;
	}
}
