#ifndef __OBJECT_ENEMY_H_
#define __OBJECT_ENEMY_H_

#include "object_character.h"
#include "object_player.h"

class ObjEnemy : public ObjCharacter
{
public:
	ObjCharacter* target;
	Vector2 aim;
	bool attached;
	UINT current_waypoint;
	int waypoint_mode;
	float waypoint_speed;
	float waypoint_speed_limit;
	Vector2 waypoint_start;
	UINT waypoint_global;

	void Process();
	void Touch(ObjPhysic *obj);
	void ParentEvent( ObjectEventInfo info );

	ObjEnemy()
	{
		this->current_waypoint = 0;
		this->type = objEnemy;
		this->aim = Vector2(0,0);
		attached = false;
		health = 1;						 //      .
		target = NULL;
	}

	~ObjEnemy()
	{
	}
};

ObjEnemy* CreateEnemy(const char* proto_name, Vector2 coord, const char* start_anim);

#endif // __OBJECT_ENEMY_H_