#ifndef __MISC_H_
#define __MISC_H_

//////////////////////////////////////////////////////////////////////////
//          
#ifdef FIND_MEM_LEAKS
//#define DEBUG_STOP_ON_ALLOC_NUM 152893
#endif // FIND_MEM_LEAKS
//////////////////////////////////////////////////////////////////////////

char* StrDupl (const char *str);

void EndupLogs();

void CheckDefaultConfig();
char* ExtFromPath(const char* path);
char* GetNameFromPath(const char* path);
void DeleteFileNameFromEndOfPathToFile(char *src);
int ChangeDir(const char* path);
bool FindFile(const char * const file_name, const char * path, char * const buffer);
bool FindAllFiles(const char * path, char * const buffer, void (*callback)(const char* const) );

void InitPaths(void);
void CheckPaths();
void CleanupLogs();
void LogPaths(void);

const char* LogLevelGetName( LogLevel ll );
//bool LogLevelLowerThan( const char* Event );

void CreateLogFile(const char *fname);
void sLog(const char* fname, LogLevel Event, const char* Format,...);
bool FileExists(const char* file_name);
/**
*	   .   . TODO!
*	        - Log      .
*/

class CDummy
{
public:
	CDummy();
	~CDummy();
};


//////////////////////////////////////////////////////////////////////////

//   ,             .
// float  ,   1e-35,   0,   0.        .
__INLINE bool IsNear(float a, float b, float accuracy)
{
	return fabs(a-b) < accuracy;
}

#endif // __MISC_H_
