#ifndef __TIMEEVENT_H_
#define __TIMEEVENT_H_

class TimerEvent
{
public:
	UINT id;					//       .

	int action;					//    

	UINT execTime;				//   

	UINT period;				//   
	UINT maxCalls;				//   

	UINT calls;					//   

	UINT flags;	
	// 1 - threadResume				  -   coroutine
	// 2 - periodic					 
	// 4 - pausable					       ,   ""
									//      

	__INLINE BYTE IsThreadResume()		{ return flags & 1; }
	__INLINE void SetThreadResume()		{ flags |= 1; }
	__INLINE void ClearThreadResume()	{ flags &= ~1; }

	__INLINE BYTE IsPeriodic()		{ return flags & 2; }
	__INLINE void SetPeriodic()		{ flags |= 2; }
	__INLINE void ClearPeriodic()	{ flags &= ~2; }

	__INLINE BYTE IsPausable()		{ return flags & 4; }
	__INLINE void SetPausable()		{ flags |= 4; }
	__INLINE void ClearPausable()	{ flags &= ~4; }

	void ExecEvent();

	TimerEvent()
	{
		id = 0;
		action = 0;
		execTime = 0;
		flags = 0;
		period = 0;
		maxCalls = 0;
		calls = 0;
	}

	~TimerEvent()
	{
		//DELETEARRAY(action);
		if (!IsThreadResume())
			SCRIPT::RemoveFromRegistry(action);
	}

};


UINT AddTimerEvent(UINT dt, int action, UINT period, UINT maxCalls);
UINT AddTimerEvent(UINT dt, int action);
void AddThreadTimerEvent(UINT dt, int action, bool pausable);
void DeleteAllEvents();
void DeleteAllThreadEvents();
int DeleteTimerEvent(int action);

void ProcessTimerEvents();

#define TIMEREVENTTICK 10


#endif // __TIMEEVENT_H_